﻿'----------------------------------------------------------------------------------------------
'    フォームクラス
'備考：
'   下記のレジストリキーを設定しておかないとWebBrowserコントロールの表示が崩れる。
'   HKEY_LOCAL_MACHINE (or HKEY_CURRENT_USER)
'       \SOFTWARE
'           \Microsoft
'               \Internet Explorer
'                   \Main
'                       \FeatureControl
'                          \FEATURE_BROWSER_EMULATION
'                               \InvoiceDownloader.exe = (DWORD) 00009000
'----------------------------------------------------------------------------------------------

Imports System.ComponentModel

Public Class MainForm

    '--- 状態 ---
    Const cintPageIdle As Integer = 0
    Const cintPageMoveToTopPage As Integer = 1
    Const cintPageLogin As Integer = 2
    Const cintPageSelectDetail As Integer = 3
    Const cintPageSelectCard As Integer = 4
    Const cintPageSelectInvoice As Integer = 5
    Const cintPageLoginComplete As Integer = 6
    Const cintPageGetOnePage As Integer = 7
    Const cintPageLogout As Integer = 8
    Const cintPageOutputFile As Integer = 9
    Const cintPageFinish As Integer = 10

    '--- クラス内グローバル(サイト毎) ---
    Dim strUsername As String               'ログインユーザ名
    Dim strPassword As String               'ログインパスワード  
    Dim strSaveDirectory As String          '保存先ディレクトリ  
    Dim strLoginURL As String               'トップページのURL

    '--- クラス内グローバル ---
    Dim intPageState As Integer = 0                 '状態変数
    Dim blnAbort As Boolean                         'ダウンロード中断要求
    Dim blnDocumentCompleted As Boolean             'WebBrowserコントロールのDocumentCompletedイベント発生状態
    Dim thrDownload As System.Threading.Thread      'ダウンロードスレッドのハンドル
    Dim blnFinalPage As Boolean
    Dim strInvoiceContent(1000, 7) As String
    Dim intContentIndex As Integer
    Dim strFileNamePostfix As String

    '----------------------------------------------------------------------------------------------
    '    イベントハンドラ
    '----------------------------------------------------------------------------------------------
    '
    '名称：開始/停止ボタンのClickイベントハンドラ
    '備考：
    '
    Private Sub btnButton1_Click(sender As Object, e As EventArgs) Handles btnStartStop.Click
        If btnStartStop.Text = "開始" Then
            btnStartStop.Text = "中断"
            intPageState = 0
            blnAbort = False
            Select Case tabSiteInformation.SelectedTab.Text
                Case "TS3"
                    strUsername = txtTS3UserName.Text
                    strPassword = txtTS3Password.Text
                    strSaveDirectory = txtTS3SaveDirectory.Text
                    StartTS3()

                Case "No2"
                    strUsername = txtTS3UserName.Text
                    strPassword = txtTS3Password.Text
                    strSaveDirectory = txtTS3SaveDirectory.Text
                    StartTS3()

                Case "No3"
                    strUsername = txtTS3UserName.Text
                    strPassword = txtTS3Password.Text
                    strSaveDirectory = txtTS3SaveDirectory.Text
                    StartTS3()

            End Select
        Else
            btnStartStop.Text = "開始"
            blnAbort = True
        End If
    End Sub
    '
    '名称：WebBrowserコントロールのドキュメント読み込み完了イベントハンドラ
    '備考：
    '
    Private Sub DocLoadedHandler()
        blnDocumentCompleted = True
    End Sub
    '
    '名称：FormクラスのLoadイベントハンドラ
    '備考：
    '
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        '設定情報をロード
        Dim objRegKey As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Downloader_REbecca")
        'TS3
        txtTS3UserName.Text = objRegKey.GetValue("UserNameTS3", "")   'ユーザ名をロード
        txtTS3Password.Text = objRegKey.GetValue("PasswordTS3", "")   'パスワードをロード
        txtTS3SaveDirectory.Text = objRegKey.GetValue("SaveDirectoryTS3", "C:\")          '保存先ディレクトリをロード
    End Sub
    '
    '名称：FormクラスのClosingイベントハンドラ
    '備考：
    '
    Private Sub Form1_Closing(sender As Object, e As EventArgs) Handles Me.Closed
        blnAbort = True             '実行中の要求をキャンセル
        '設定情報をセーブ
        Dim objRegKey As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Downloader")
        'TS3
        objRegKey.SetValue("UserNameTS3", txtTS3UserName.Text)                  'ユーザ名をセーブ
        objRegKey.SetValue("PasswordTS3", txtTS3Password.Text)                  'パスワードをセーブ
        objRegKey.SetValue("SaveDirectoryTS3", txtTS3SaveDirectory.Text)        '保存先ディレクトリをセーブ
        'No2
        objRegKey.SetValue("UserNameNo2", txtNo2Username.Text)                  'ユーザ名をセーブ
        objRegKey.SetValue("PasswordNo2", txtNo2Password.Text)                  'パスワードをセーブ
        objRegKey.SetValue("SaveDirectoryNo2", txtNo2SaveDirectory.Text)        '保存先ディレクトリをセーブ
        'No3
        objRegKey.SetValue("UserNameNo3", txtNo3Username.Text)                  'ユーザ名をセーブ
        objRegKey.SetValue("PasswordNo3", txtNo3Password.Text)                  'パスワードをセーブ
        objRegKey.SetValue("SaveDirectoryNo3", txtNo3SaveDirectory.Text)        '保存先ディレクトリをセーブ
    End Sub
    '----------------------------------------------------------------------------------------------
    '    共通関数
    '----------------------------------------------------------------------------------------------
    '
    '名称：WebBrowserオブジェクトのNavigateメソッドをコール
    '備考：
    '   ・日付時刻を付けて出力ウィンドウとログテキストボックスへログを出力
    '
    Delegate Sub dlgNavigate(strOutput As String)
    Private Sub Navigate(strURL As String)
        WebBrowser.Navigate(strURL)
    End Sub
    '
    '名称：WebBrowserオブジェクトのNavigateメソッドの完了を待つ
    '備考：
    '   ・WebBrowserオブジェクトのDocumentCompletedイベントも待たないと稀に完了を取りこぼす。
    '   ・本来は、WebBrowser.Navigateをコールする前にblnDocumentCompleted=falseとAddHandlerすべきだが、
    '     利便性を考え、本関数内で行う設計とする。
    '
    Delegate Sub dlgWaitNavigation()
    Private Sub WaitNavigation()
        blnDocumentCompleted = False
        WebBrowser.Document.Body.Style &= ";Zoom:33%"
        AddHandler WebBrowser.DocumentCompleted, AddressOf DocLoadedHandler
        While WebBrowser.IsBusy OrElse (WebBrowser.ReadyState <> WebBrowserReadyState.Complete) OrElse Not blnDocumentCompleted
            System.Windows.Forms.Application.DoEvents()
        End While
    End Sub
    '
    '名称：ログを出力
    '備考：
    '   ・日付時刻を付けて出力ウィンドウとログテキストボックスへログを出力
    '
    Delegate Sub dlgLog(strOutput As String)
    Private Sub Log(strOutput As String)
        Console.Write(System.DateTime.Now.ToString("yyyy/MM/dd hh:mm:ss") & strOutput & vbNewLine)
        txtLog.Text = System.String.Format(System.DateTime.Now.ToString("yyyy/MM/dd hh:mm:ss ") & strOutput & vbNewLine) & txtLog.Text
    End Sub
    '
    '名称：開始ボタンを有効化
    '備考：
    '
    Delegate Sub dlgReadFinish()
    Private Sub ReadFinish()
        btnStartStop.Text = "開始"
    End Sub
End Class