﻿'
'名称：TS3ダウンロードスレッドと関数群
'備考：
'   別スレッドからフォームを作成したスレッドの関数をコールする方法
'       方法1
'           Dim call1back As dlgLog = New dlgLog(AddressOf Log)
'           Invoke(call1back, "文字列型のパラメータ")
'       方法2
'           Invoke(New dlgLog(AddressOf Log), "文字列型のパラメータ")
'
'備考
'   class属性を参照する場合だけは、GetAttribute("className")でアクセス
'   他の属性はGetAttribute("属性名")で参照できる。
'
Partial Class MainForm
    '
    '名称：ダウンロードを開始
    '備考：
    '
    Private Sub StartTS3()
        'サイト固有の変数を初期化
        strLoginURL = "https://my.ts3card.com/webapp/ToTP01020101Action.do?command=doInit&UNIQUEID=80691" 'トップページのURL
        'ダウンロードスレッドを起動
        thrDownload = New System.Threading.Thread(New System.Threading.ThreadStart(AddressOf DownloadThread_TS3))
        thrDownload.IsBackground = True
        thrDownload.Start()
    End Sub
    '
    '名称：ダウンロードスレッド本体
    '備考：
    '
    Private Sub DownloadThread_TS3()
        While 1
            Select Case intPageState
                Case cintPageIdle           '初期状態
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】初期状態"))
                    intPageState = cintPageMoveToTopPage

                Case cintPageMoveToTopPage  'トップページへ遷移
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】トップページへ遷移"))
                    Invoke(New dlgPageOpenTopPage(AddressOf PageOpenTopPage))
                    intPageState = cintPageLogin

                Case cintPageLogin  'ログイン
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】ログイン"))
                    Invoke(New dlgPageLogin(AddressOf LegsLogin))
                    intPageState = cintPageSelectDetail

                Case cintPageSelectDetail  '詳細選択
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】詳細選択"))
                    Invoke(New dlgPageSelectDetail(AddressOf PageSelectDetail))
                    intPageState = cintPageSelectCard

                Case cintPageSelectCard     'カード選択
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】カード選択"))
                    Invoke(New dlgPageSelectCard(AddressOf PageSelectCard))
                    intPageState = cintPageSelectInvoice

                Case cintPageSelectInvoice  '請求書選択
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】請求書選択"))
                    Invoke(New dlgPageSelectInvoice(AddressOf PageSelectInvoice))
                    intPageState = cintPageLoginComplete

                Case cintPageLoginComplete  'ログイン完了
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】ログイン完了"))
                    System.Threading.Thread.Sleep(1000)     '1秒待つ
                    blnFinalPage = False
                    intContentIndex = 0
                    intPageState = cintPageGetOnePage

                Case cintPageGetOnePage     '1ページ分のデータを取得
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】ページ取得"))
                    If blnFinalPage Then
                        intPageState = cintPageLogout
                    Else
                        Invoke(New dlgPageGetOnePage(AddressOf PageGetOnePage))
                    End If

                Case cintPageLogout         'ログアウト
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】ログアウト"))
                    Invoke(New dlgPageLogout(AddressOf PageLogout))
                    intPageState = cintPageOutputFile

                Case cintPageOutputFile        'ファイルへ出力
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】ファイル出力"))
                    Invoke(New dlgPageOutputFile(AddressOf PageOutputFile))
                    intPageState = cintPageFinish

                Case cintPageFinish         '終了
                    Invoke(New dlgLog(AddressOf Log), String.Format("【状態】終了"))
                    Invoke(New dlgReadFinish(AddressOf ReadFinish))
                    Exit Sub

            End Select
            '中断要求がある場合はSubを抜ける
            If blnAbort Then
                blnAbort = False
                Invoke(New dlgLog(AddressOf Log), String.Format("【状態】ダウンロードを中断"))
                Invoke(New dlgReadFinish(AddressOf ReadFinish))
                Exit Sub
            End If
        End While
    End Sub

    Delegate Sub dlgPageOpenTopPage()
    Private Sub PageOpenTopPage()
        '指定されたURLを開く
        WebBrowser.Navigate(strLoginURL)
        'ページの表示が完了するまで待つ
        WaitNavigation()
    End Sub

    Delegate Sub dlgPageLogin()
    Private Sub LegsLogin()
        'ユーザ名を入力
        Dim blnFoundID As Boolean = False
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("ph1").All
            If objElem.TagName = "INPUT" And objElem.GetAttribute("NAME") = "vo.loginId" Then
                objElem.InnerText = strUsername
                blnFoundID = True
            End If
        Next
        'パスワードを入力
        Dim blnFoundPass As Boolean = False
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("ph2").All
            If objElem.TagName = "INPUT" And objElem.GetAttribute("NAME") = "vo.password" Then
                objElem.InnerText = strPassword
                blnFoundPass = True
            End If
        Next
        If Not blnFoundID Or Not blnFoundPass Then
            Log(String.Format("【状態】ログイン…入力欄未発見"))
            Exit Sub
        End If
        'ログインボタンを押す
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("Main").All
            If objElem.TagName = "DIV" And objElem.GetAttribute("ClassName") = "btn-login" Then
                Dim objElem2 As Object
                objElem2 = objElem.GetElementsByTagName("a")
                If objElem2.count = 1 Then
                    objElem2(0).InvokeMember("Click")
                    Log(String.Format("【状態】ログイン…リンクをクリック"))
                    'ページの表示が完了するまで待つ
                    WaitNavigation()
                    Exit Sub
                End If
            End If
        Next
        Log(String.Format("【状態】ログイン…リンク未発見"))
    End Sub

    Delegate Sub dlgPageSelectDetail()
    Private Sub PageSelectDetail()
        '詳細ボタンを押す
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("MeisaiDetail").All
            If objElem.TagName = "A" Then
                objElem.InvokeMember("click")
                Log(String.Format("【状態】詳細選択…リンクをクリック"))
                'ページの表示が完了するまで待つ
                WaitNavigation()
                Exit Sub
            End If
        Next
        Log(String.Format("【状態】詳細選択…リンク未発見"))
    End Sub

    Delegate Sub dlgPageSelectCard()
    Private Sub PageSelectCard()
        '次ページボタンを押す
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("center").All
            If objElem.TagName = "A" Then
                objElem.InvokeMember("Click")
                Log(String.Format("【状態】カード選択…リンクをクリック"))
                'ページの表示が完了するまで待つ
                WaitNavigation()
                Exit Sub
            End If
        Next
        Log(String.Format("【状態】カード選択…リンク未発見"))
    End Sub

    Delegate Sub dlgPageSelectInvoice()
    Private Sub PageSelectInvoice()
        Dim SearchState As Integer = 0
        '今月のご利用明細リンクを押す
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("wrap").All
            Select Case SearchState
                Case 0  'TABLEタグを探す
                    If objElem.TagName = "TABLE" And objElem.GetAttribute("ClassName") = "claim_table col3" Then
                        SearchState = 1
                    End If
                Case 1  '1個目のTRタグを探す
                    If objElem.TagName = "TR" Then
                        SearchState = 2
                    End If
                Case 2  '2個目のTRタグを探す
                    If objElem.TagName = "TR" Then
                        SearchState = 3
                    End If
                Case 3  'THタグを探す
                    If objElem.TagName = "TH" Then
                        SearchState = 4
                    End If
                Case 4  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strFileNamePostfix = objElem.InnerText
                        SearchState = 5
                    End If
                Case 5  '1個目のTDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 6
                    End If
                Case 6  '2個目のTDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 7
                    End If
                Case 7  'aタグを探す
                    If objElem.TagName = "A" Then
                        objElem.InvokeMember("Click")
                        Log(String.Format("【状態】請求書選択…リンクをクリック"))
                        'ページの表示が完了するまで待つ
                        WaitNavigation()
                        Exit Sub
                    End If
            End Select
        Next
        Log(String.Format("【状態】請求書選択…リンク未発見"))
    End Sub

    Delegate Sub dlgPageGetOnePage()
    Private Sub PageGetOnePage()
        'ページ内のデータを取得
        Dim SearchState As Integer = 0
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("wrap").All
            Select Case SearchState
                Case 0  'TABLEタグを探す
                    If objElem.TagName = "DIV" And objElem.GetAttribute("ClassName") = "meisaiTableDetailWrap" Then
                        SearchState = 1
                    End If
                Case 1  'TBODYタグを探す
                    If objElem.TagName = "DIV" Then
                        SearchState = 23
                    End If
                    If objElem.TagName = "TBODY" Then
                        SearchState = 2
                    End If
                Case 2  'THタグを探す
                    If objElem.TagName = "TH" Then
                        SearchState = 3
                    End If
                Case 3  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strInvoiceContent(intContentIndex, 0) = objElem.InnerText
                        SearchState = 4
                    End If
                Case 4  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        SearchState = 5
                    End If
                Case 5  'TDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 6
                    End If
                Case 6  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        SearchState = 7
                    End If
                Case 7  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strInvoiceContent(intContentIndex, 1) = objElem.InnerText
                        SearchState = 8
                    End If
                Case 8  'TDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 9
                    End If
                Case 9  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        SearchState = 10
                    End If
                Case 10  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strInvoiceContent(intContentIndex, 2) = objElem.InnerText
                        SearchState = 11
                    End If
                Case 11  'TDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 12
                    End If
                Case 12  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        SearchState = 13
                    End If
                Case 13  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strInvoiceContent(intContentIndex, 3) = objElem.InnerText
                        strInvoiceContent(intContentIndex, 3) = strInvoiceContent(intContentIndex, 3).Replace("円", "")
                        strInvoiceContent(intContentIndex, 3) = strInvoiceContent(intContentIndex, 3).Replace(",", "")
                        SearchState = 14
                    End If
                Case 14  'TDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 15
                    End If
                Case 15  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        SearchState = 16
                    End If
                Case 16  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strInvoiceContent(intContentIndex, 4) = objElem.InnerText
                        SearchState = 17
                    End If
                Case 17  'TDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 18
                    End If
                Case 18  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        SearchState = 19
                    End If
                Case 19  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strInvoiceContent(intContentIndex, 5) = objElem.InnerText
                        SearchState = 20
                    End If
                Case 20  'TDタグを探す
                    If objElem.TagName = "TD" Then
                        SearchState = 21
                    End If
                Case 21  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        SearchState = 22
                    End If
                Case 22  'SPANタグを探す
                    If objElem.TagName = "SPAN" Then
                        strInvoiceContent(intContentIndex, 6) = objElem.InnerText
                        strInvoiceContent(intContentIndex, 6) = strInvoiceContent(intContentIndex, 6).Replace("円", "")
                        strInvoiceContent(intContentIndex, 6) = strInvoiceContent(intContentIndex, 6).Replace(",", "")
                        intContentIndex = intContentIndex + 1
                        SearchState = 1
                    End If
                Case 23  '終了(何もしない)
            End Select
        Next
        '最終ページかどうかを判断
        blnFinalPage = True
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("center").All
            If objElem.TagName = "A" And objElem.InnerText = "次ページへ" Then
                blnFinalPage = False
                objElem.InvokeMember("Click")
                Log(String.Format("【状態】ページ読み込み…次のページへ"))
                'ページの表示が完了するまで待つ
                WaitNavigation()
                Exit Sub
            End If
        Next
        Log(String.Format("【状態】ページ読み込み…終了"))
    End Sub

    Delegate Sub dlgPageOutputFile()
    Private Sub PageOutputFile()
        Dim OutputFile As IO.StreamWriter
        Dim strLine As String

        Try
            OutputFile = New IO.StreamWriter(strSaveDirectory & "\TS3請求書_" & strFileNamePostfix & ".csv", False, System.Text.Encoding.GetEncoding("shift_jis"))
        Catch ex As system.io.IOException
            MsgBox("指定された場所にファイルを作成できません。" & vbCrLf & "中断します。",, "請求書ダウンローダ")
            Return
        End Try
        OutputFile.WriteLine("日付,利用者,利用店,利用金額,支払方法,摘要,今回請求額")
        For i = 0 To strInvoiceContent.GetLength(0) - 1
            If strInvoiceContent(i, 0) IsNot Nothing Then
                strLine = strInvoiceContent(i, 0) & "," &
                        strInvoiceContent(i, 1) & "," &
                        strInvoiceContent(i, 2) & "," &
                        strInvoiceContent(i, 3) & "," &
                        strInvoiceContent(i, 4) & "," &
                        strInvoiceContent(i, 5) & "," &
                        strInvoiceContent(i, 6)
                OutputFile.WriteLine(strLine)
            End If
        Next
        OutputFile.Close()
        OutputFile.Dispose()
    End Sub

    Delegate Sub dlgPageLogout()
    Private Sub PageLogout()
        For Each objElem As HtmlElement In WebBrowser.Document.GetElementById("global_header").All
            If objElem.TagName = "A" And objElem.InnerText = "ログアウト" Then
                objElem.InvokeMember("Click")
                Log(String.Format("【状態】ログアウト…リンクをクリック"))
                'ページの表示が完了するまで待つ
                WaitNavigation()
                Exit Sub
            End If
        Next
        Log(String.Format("【状態】ログアウト リンク未発見"))
    End Sub

End Class
